#include <linux/init.h>
#include <linux/module.h>
#include <linux/ioctl.h>
#include <linux/fs.h>

#define MAJOR_NUM 235
#define DEVNAME "free_dma_dev"
#define TEST _IOWR(MAJOR_NUM, 5, int *)

extern void extern_ppe_exit(void);

int device_conn_ioctl(
                struct inode *inode,
                struct file *file,
                unsigned int ioctl_num,
                unsigned long ioctl_param) 
{
	int *option=NULL;
	int ret=0;

	switch(ioctl_num) {
		case TEST:
			option = (int *)ioctl_param;
			printk("IOCTL received val[%d] at (%s:%d)\n", *option,  __FUNCTION__, __LINE__);
			if (!option) {
				printk("Recd. NULL option from userspace. Do Nothing\n");
			}	
			else {
				if (*option == 1)
				{
					printk("[KERNEL] free LAN side DMA\n");
					extern_sw_exit();
					//close_rx_dma();
				}
				else if (*option == 2)
				{
					printk("[KERNEL] free WAN side DMA\n");
					extern_ppe_exit();	
				}	
				else
				{
					printk("[KERNEL] option [%d] not recognized\n", *option);
				}
			}
			break;
	}

	return ret;
}

static int device_conn_open(struct inode *inode,struct file *file)
{
	printk("OPEN\n");
	return 0;
}

struct file_operations Fconn_ops = {
	read: device_conn_open,
	write: NULL,
	readdir: NULL,
	poll: NULL,
	ioctl: device_conn_ioctl,
	mmap: NULL,
	open: device_conn_open,
	flush: NULL
};

static void fini(void)
{
	int ret=0;

	ret = unregister_chrdev(MAJOR_NUM, DEVNAME);
	if (ret <0)
		printk("Error in module unregister_chrdev: (%d)\n", ret);
}

static int init(void)
{
        int ret=0;
        printk("\n\n(%s)::init: Registering device [%s]\n", __FUNCTION__, DEVNAME);
        ret = register_chrdev(MAJOR_NUM, DEVNAME, &Fconn_ops);
        if(ret<0) {
                printk("Sorry, registering the char device with return value %d\n", ret);
        }
        return ret;
}


module_init(init);
module_exit(fini);

MODULE_LICENSE("GPL");


